@echo off
setlocal
color 0C
echo.
echo.
echo.
rem Esegui lo script come amministratore
openfiles >nul 2>&1
if '%errorlevel%' NEQ '0' (
    echo Stai per eseguire lo script con privilegi di Amministratore, dai invio per confermare.
    pause
    powershell -Command "Start-Process '%~f0' -Verb RunAs"
    exit
)

color B0
:: Mostra un popup di benvenuto
powershell -Command "& {Add-Type -AssemblyName PresentationFramework; [System.Windows.MessageBox]::Show('Benvenuto! Stai per utilizzare gestione punti di ripristino di Kris / Mister-Pc')}"

echo.
echo                  Benvenuto! stai per utilizzare degli script di Mister-Pc
echo                  Canale you tube: https://www.youtube.com/@Mister-Pc-Kris 
echo                         Sito web: https://tecnomaniaci.com/
echo.

:menu
echo Scegli un'opzione:
echo 1. Programmare un punto di ripristino automatico
echo 2. Creare un punto di ripristino manuale ora
echo 3. Gestire il blocco per la creazione di punti di ripristino
echo 4. Esci

set /p choice=Inserisci la tua scelta (1, 2, 3, o 4): 

if "%choice%"=="1" goto restore_menu
if "%choice%"=="2" goto manual
if "%choice%"=="3" goto block_menu
if "%choice%"=="4" goto exit

:: Ritorna al menu se la scelta non è valida
goto menu

:restore_menu
echo.
echo Scegli un'opzione per programmare il punto di ripristino:
echo 1. Ogni giorno alle 12:00
echo 2. Ogni 5 giorni alle 12:00
echo 3. Ogni 10 giorni alle 12:00

set /p restore_choice=Inserisci la tua scelta (1, 2 o 3): 

set task_name=
set script_desc=

if "%restore_choice%"=="1" (
    set task_name="Punto di Ripristino Automatico Giornaliero"
    set script_desc="Punto di ripristino automatico giornaliero"
    goto schedule
) else if "%restore_choice%"=="2" (
    set task_name="Punto di Ripristino Automatico Ogni 5 Giorni"
    set script_desc="Punto di ripristino automatico ogni 5 giorni"
    goto schedule
) else if "%restore_choice%"=="3" (
    set task_name="Punto di Ripristino Automatico Ogni 10 Giorni"
    set script_desc="Punto di ripristino automatico ogni 10 giorni"
    goto schedule
) else (
    echo Scelta non valida. Torno al menu principale.
    goto menu
)

:schedule
:: Cancella eventuali task precedenti con lo stesso nome
schtasks /delete /tn "Punto di Ripristino Automatico Giornaliero" /f >nul 2>&1
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 5 Giorni" /f >nul 2>&1
schtasks /delete /tn "Punto di Ripristino Automatico Ogni 10 Giorni" /f >nul 2>&1

:: Crea lo script PowerShell per creare un punto di ripristino in C:\Program Files
echo Checkpoint-Computer -Description "%script_desc%" -RestorePointType "MODIFY_SETTINGS" > "C:\Program Files\CreateRestorePoint.ps1"

:: Programma il Task Scheduler con i parametri appropriati
if "%restore_choice%"=="1" (
    schtasks /create /tn %task_name% /tr "powershell.exe -ExecutionPolicy Bypass -File \"C:\Program Files\CreateRestorePoint.ps1\"" /sc daily /st 12:00 /rl highest /f
) else if "%restore_choice%"=="2" (
    schtasks /create /tn %task_name% /tr "powershell.exe -ExecutionPolicy Bypass -File \"C:\Program Files\CreateRestorePoint.ps1\"" /sc daily /mo 5 /st 12:00 /rl highest /f
) else if "%restore_choice%"=="3" (
    schtasks /create /tn %task_name% /tr "powershell.exe -ExecutionPolicy Bypass -File \"C:\Program Files\CreateRestorePoint.ps1\"" /sc daily /mo 10 /st 12:00 /rl highest /f
)

echo Task Scheduler programmato con successo.
goto end

:manual
:: Chiedi all'utente di inserire il nome del punto di ripristino
set /p nomeRipristino=Inserisci il nome del punto di ripristino: 
:: Creare un punto di ripristino utilizzando PowerShell
powershell.exe -Command "Checkpoint-Computer -Description '%nomeRipristino%' -RestorePointType 'MODIFY_SETTINGS'"
echo Punto di ripristino creato con successo.
goto end

:block_menu
echo Qui sotto lo stato di attivazione della tua chiave di registro. 

rem Controlla lo stato attuale della chiave di registro
set status=non impostata
for /f "tokens=3" %%a in ('reg query "HKLM\Software\Microsoft\Windows NT\CurrentVersion\SystemRestore" /v SystemRestorePointCreationFrequency 2^>nul') do (
    if "%%a"=="0x0" (
        set status=disattiva
    ) else (
        set status=attiva
    )
)
echo Attualmente, la chiave e' %status%.

echo.
echo Scegli un'opzione:
echo 1. Abilita il blocco predefinito di 24 ore
echo 2. Disabilita il blocco, permettendo punti di ripristino senza limitazioni

set /p block_choice=Inserisci il numero dell'opzione desiderata: 

if %block_choice%==1 (
    rem Abilita il blocco di 24 ore (1440 minuti)
    reg add "HKLM\Software\Microsoft\Windows NT\CurrentVersion\SystemRestore" /v SystemRestorePointCreationFrequency /t REG_DWORD /d 1440 /f
    echo Blocco di 24 ore abilitato.
) else if %block_choice%==2 (
    rem Disabilita il blocco, permettendo punti di ripristino senza limitazioni
    reg add "HKLM\Software\Microsoft\Windows NT\CurrentVersion\SystemRestore" /v SystemRestorePointCreationFrequency /t REG_DWORD /d 0 /f
    echo Blocco disabilitato, ora puoi creare punti di ripristino senza limitazioni.
) else (
    echo Scelta non valida. Torno al menu principale.
)

goto end

:end
pause
goto menu

:exit
echo Uscita.
exit /b